"use strict";
var platform_1 = require("platform");
var Buffer = require('buffer/').Buffer;
var bcrypt_1 = require("./bcrypt");
exports.bcrypt = bcrypt_1.bcrypt;
if (platform_1.isIOS) {
    // security
    var randomBytes = function (length) {
        var bytes = NSMutableData.dataWithLength(length);
        SecRandomCopyBytes(null, length, bytes.mutableBytes);
        var buf = new Buffer(bytes.base64EncodedStringWithOptions(0), 'base64');
        return buf;
    };
    bcrypt_1.bcrypt.setRandomFallback(randomBytes);
}
else if (platform_1.isAndroid) {
    var randomBytes = function (length) {
        var output = Array.create("byte", length);
        new java.security.SecureRandom().nextBytes(output);
        var buf = new Buffer(android.util.Base64.encodeToString(output, android.util.Base64.DEFAULT), 'base64');
        return buf;
    };
    bcrypt_1.bcrypt.setRandomFallback(randomBytes);
}
else {
    throw "unknown platform execution";
}
